
import java.util.ArrayList;
import java.util.Collections;

/**
 *
 * @author Lefteris Moussiades
 */
public class Deck {

    private final ArrayList<Card> deck;
    private final int top = 0;

    public Deck() {
        deck = new ArrayList<>(52);
        for (CardRank r : CardRank.values()) {
            for (Suit s : Suit.values()) {
                deck.add(new Card(r, s));
            }
        }
    }

    public void shuffle() {
        Collections.shuffle(deck);
    }

    public boolean empty() {
        return deck.isEmpty();
    }

    public Card pickCard() {
        return deck.remove(top);
    }

    public static void main(String[] args) {
        Deck d = new Deck();
        d.shuffle();
        while (!d.empty()) {
            System.out.println(d.pickCard());
        }
    }

}
